/*
 * drivers/char/xilinx_fsl/fslfifo_ioctl.h
 *
 * IOCTL constants for the MicroBlaze FSL FIFO device driver
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * Copyright 2008 LynuxWorks
 *
 */

#ifndef _FSLFIFO_IOCTL_H
#define _FSLFIFO_IOCTL_H

#include <linux/ioctl.h>
#include <linux/types.h>

/* Data structure for FLSFIFO_CPUT and FLSFIFO_CGET */

struct fslfifo_ioctl_data {
	__u32 data;
	__u32 status;
};

/* Status bits for FLSFIFO_CGET */

#define FSLFIFO_EAGAIN		0x01 /* no data for read / no space for write */
#define FSLFIFO_NOCONTROL	0x02 /* no control bit set when reading */

#define FSLFIFO_IOCTL_BASE 'X'

#define FSLFIFO_CPUT	_IOWR(FSLFIFO_IOCTL_BASE, 1, struct fslfifo_ioctl_data)
#define FSLFIFO_CGET	_IOWR(FSLFIFO_IOCTL_BASE, 2, struct fslfifo_ioctl_data)
#define FSLFIFO_DW_SET	_IOW(FSLFIFO_IOCTL_BASE, 3, unsigned)
#define FSLFIFO_DW_GET	_IOR(FSLFIFO_IOCTL_BASE, 4, unsigned)

#endif /* _FSLFIFO_IOCTL_H */
