##############################################################################
#
#     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
#     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
#     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
#     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
#     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
#     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
#     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
#     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
#     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
#     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
#     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
#     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
#     FOR A PARTICULAR PURPOSE.
#
#     (c) Copyright 2004-2008 Xilinx, Inc.
#     All rights reserved.
#
##############################################################################

export CONFIG_FILE=$1

create() {
	echo creating $CONFIG_PARAMETER
	echo \# $CONFIG_PARAMETER is not set >> $CONFIG_FILE
}

check() {
	grep "$CONFIG_PARAMETER[ =]" $CONFIG_FILE >/dev/null || create
}

disable() {
	echo disabling $CONFIG_PARAMETER
	check
	sed -e "/$CONFIG_PARAMETER[ =]/s/^.*$/# $CONFIG_PARAMETER is not set/" <$CONFIG_FILE >$CONFIG_FILE.out
	mv -f $CONFIG_FILE.out $CONFIG_FILE
}

enable() {
	echo enabling $CONFIG_PARAMETER
	check
	sed -e "/$CONFIG_PARAMETER[ =]/s/^.*$/$CONFIG_PARAMETER=y/" <$CONFIG_FILE >$CONFIG_FILE.out
	mv -f $CONFIG_FILE.out $CONFIG_FILE
}

setval() {
	echo set $CONFIG_PARAMETER to $PARAMETER_VALUE
	check
	sed -e "/$CONFIG_PARAMETER[ =]/s/^.*$/$CONFIG_PARAMETER=$PARAMETER_VALUE/" <$CONFIG_FILE >$CONFIG_FILE.out
	mv -f $CONFIG_FILE.out $CONFIG_FILE
}


disable_temac() {
	CONFIG_PARAMETER="CONFIG_XILINX_TEMAC"
	disable
}

enable_temac() {
	CONFIG_PARAMETER="CONFIG_XILINX_TEMAC"
	enable
}

disable_emac() {
	CONFIG_PARAMETER="CONFIG_XILINX_EMAC"
	disable
}

enable_emac() {
	CONFIG_PARAMETER="CONFIG_XILINX_EMAC"
	enable
}

disable_emaclite() {
	CONFIG_PARAMETER="CONFIG_XILINX_EMACLITE"
	disable
}

enable_emaclite() {
	CONFIG_PARAMETER="CONFIG_XILINX_EMACLITE"
	enable
}

disable_lltemac() {
	CONFIG_PARAMETER="CONFIG_XILINX_LL_TEMAC"
	disable
}

enable_lltemac() {
	CONFIG_PARAMETER="CONFIG_XILINX_LL_TEMAC"
	enable
}

enable_sysace() {
	CONFIG_PARAMETER="CONFIG_XILINX_SYSACE"
	enable
}

disable_sysace() {
	CONFIG_PARAMETER="CONFIG_XILINX_SYSACE"
	disable
}

enable_spi() {
	CONFIG_PARAMETER="CONFIG_XILINX_SPI"
	enable
}

disable_spi() {
	CONFIG_PARAMETER="CONFIG_XILINX_SPI"
	disable
}

enable_iic() {
	CONFIG_PARAMETER="CONFIG_I2C"
	enable
	CONFIG_PARAMETER="CONFIG_I2C_CHARDEV"
	disable
	CONFIG_PARAMETER="CONFIG_I2C_ALGOBIT"
	disable	
	CONFIG_PARAMETER="CONFIG_I2C_ALGOPCF"
	disable	
	CONFIG_PARAMETER="CONFIG_I2C_ALGOPCA"
	disable	
	CONFIG_PARAMETER="CONFIG_I2C_ISA"
	disable	
	CONFIG_PARAMETER="CONFIG_I2C_MPC"
	disable	
	CONFIG_PARAMETER="CONFIG_I2C_PARPORT_LIGHT"
	disable	
	CONFIG_PARAMETER="CONFIG_I2C_PCA_ISA"
	disable	
	CONFIG_PARAMETER="CONFIG_I2C_SENSOR"
	disable	
	CONFIG_PARAMETER="CONFIG_SENSORS_DS1337"
	disable	
	CONFIG_PARAMETER="CONFIG_SENSORS_DS1374"
	disable	
	CONFIG_PARAMETER="CONFIG_SENSORS_EEPROM"
	disable	
	CONFIG_PARAMETER="CONFIG_SENSORS_PCF8574"
	disable	
	CONFIG_PARAMETER="CONFIG_SENSORS_PCA9539"
	disable	
	CONFIG_PARAMETER="CONFIG_SENSORS_PCF8591"
	disable	
	CONFIG_PARAMETER="CONFIG_SENSORS_RTC8564"
	disable	
	CONFIG_PARAMETER="CONFIG_SENSORS_M41T00"
	disable	
	CONFIG_PARAMETER="CONFIG_SENSORS_MAX6875"
	disable	
	CONFIG_PARAMETER="CONFIG_I2C_DEBUG_CORE"
	disable	
	CONFIG_PARAMETER="CONFIG_I2C_DEBUG_ALGO"
	disable	
	CONFIG_PARAMETER="CONFIG_I2C_DEBUG_BUS"
	disable	
	CONFIG_PARAMETER="CONFIG_I2C_DEBUG_CHIP"
	disable	
}

enable_xilinx_iic() {
	CONFIG_PARAMETER="CONFIG_XILINX_IIC"
	enable
}

disable_xilinx_iic() {
	CONFIG_PARAMETER="CONFIG_XILINX_IIC"
	disable
}

enable_gpio() {
	CONFIG_PARAMETER="CONFIG_XILINX_GPIO"
	enable
}

disable_gpio() {
	CONFIG_PARAMETER="CONFIG_XILINX_GPIO"
	disable
}

disable_uartlite() {
	CONFIG_PARAMETER="CONFIG_SERIAL_XILINX_UARTLITE"
	disable
}

disable_uartlite_console() {
	CONFIG_PARAMETER="CONFIG_SERIAL_XILINX_UARTLITE_CONSOLE"
	disable
}

enable_uartlite() {
	CONFIG_PARAMETER="CONFIG_SERIAL_XILINX_UARTLITE"
	enable
}

enable_uartlite_console() {
	CONFIG_PARAMETER="CONFIG_SERIAL_CORE_CONSOLE"
	enable
	CONFIG_PARAMETER="CONFIG_SERIAL_XILINX_UARTLITE_CONSOLE"
	enable
	CONFIG_PARAMETER="CONFIG_UNIX98_PTYS"
	enable
	CONFIG_PARAMETER="CONFIG_LEGACY_PTY_COUNT"
	PARAMETER_VALUE=256
	setval
	CONFIG_PARAMETER="CONFIG_DEVPTS_FS_XATTR"
	enable
	CONFIG_PARAMETER="CONFIG_DEVPTS_FS_SECURITY"
	enable
}

disable_16550() {
	CONFIG_PARAMETER="CONFIG_SERIAL_8250"
	disable
}


disable_16550_console() {
	CONFIG_PARAMETER="CONFIG_SERIAL_8250_CONSOLE"
	disable
	CONFIG_PARAMETER="CONFIG_SERIAL_CORE_CONSOLE"
	disable
}

enable_16550() {
	CONFIG_PARAMETER="CONFIG_SERIAL_8250"
	enable
	CONFIG_PARAMETER="CONFIG_SERIAL_8250_NR_UARTS"
	PARAMETER_VALUE=4
	setval
	CONFIG_PARAMETER="CONFIG_SERIAL_8250_EXTENDED"
	enable
	CONFIG_PARAMETER="CONFIG_SERIAL_8250_MANY_PORTS"
	enable
	CONFIG_PARAMETER="CONFIG_SERIAL_8250_SHARE_IRQ"
	enable
	CONFIG_PARAMETER="CONFIG_SERIAL_8250_DETECT_IRQ"
	enable
	CONFIG_PARAMETER="CONFIG_SERIAL_8250_RSA"
	enable
}


enable_16550_console() {
	enable_16550
	CONFIG_PARAMETER="CONFIG_SERIAL_8250_CONSOLE"
	enable
	CONFIG_PARAMETER="CONFIG_SERIAL_CORE_CONSOLE"
	enable
	CONFIG_PARAMETER="CONFIG_UNIX98_PTYS"
	enable
	CONFIG_PARAMETER="CONFIG_LEGACY_PTY_COUNT"
	PARAMETER_VALUE=256
	setval
	CONFIG_PARAMETER="CONFIG_DEVPTS_FS_XATTR"
	enable
	CONFIG_PARAMETER="CONFIG_DEVPTS_FS_SECURITY"
	enable	
}


disable_mtd() {
	CONFIG_PARAMETER="CONFIG_MTD"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_DEBUG"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_CONCAT"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_REDBOOT_PARTS"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_CMDLINE_PARTS"
	disable
	CONFIG_PARAMETER="CONFIG_FTL"
	disable
	CONFIG_PARAMETER="CONFIG_NFTL"
	disable
	CONFIG_PARAMETER="CONFIG_INFTL"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_JEDECPROBE"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_CFI_ADV_OPTIONS"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_CFI_AMDSTD"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_CFI_STAA"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_RAM"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_ROM"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_ABSENT"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_PHYSMAP"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_PLATRAM"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_SLRAM"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_PHRAM"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_MTDRAM"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_BLKMTD"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_DOC2000"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_DOC2001"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_DOC2001PLUS"
	disable
	CONFIG_PARAMETER="CONFIG_MTD_NAND"
	disable
}

enable_mtd() {
	CONFIG_PARAMETER="CONFIG_MTD"
	enable
	CONFIG_PARAMETER="CONFIG_MTD_PARTITIONS"
	enable
	CONFIG_PARAMETER="CONFIG_MTD_CHAR"
	enable
	CONFIG_PARAMETER="CONFIG_MTD_BLOCK"
	enable
	CONFIG_PARAMETER="CONFIG_MTD_CFI"
	enable
	CONFIG_PARAMETER="CONFIG_MTD_GEN_PROBE"
	enable
	CONFIG_PARAMETER="CONFIG_MTD_MAP_BANK_WIDTH_1"
	enable
	CONFIG_PARAMETER="CONFIG_MTD_MAP_BANK_WIDTH_2"
	enable
	CONFIG_PARAMETER="CONFIG_MTD_MAP_BANK_WIDTH_4"
	enable
	CONFIG_PARAMETER="CONFIG_MTD_CFI_I1"
	enable
	CONFIG_PARAMETER="CONFIG_MTD_CFI_I2"
	enable
	CONFIG_PARAMETER="CONFIG_MTD_CFI_INTELEXT"
	enable
	CONFIG_PARAMETER="CONFIG_MTD_CFI_UTIL"
	enable
	CONFIG_PARAMETER="CONFIG_MTD_COMPLEX_MAPPINGS"
	enable
	CONFIG_PARAMETER="CONFIG_JFFS_FS"
	check
	CONFIG_PARAMETER="CONFIG_JFFS2_FS"
	check
}

enable_ml403_flash() {
	CONFIG_PARAMETER="CONFIG_MTD_ML403"
	enable
}

enable_opb_flash() {
	CONFIG_PARAMETER="CONFIG_MTD_XILINX_OPB"
	enable
}

enable_emc_flash() {
	CONFIG_PARAMETER="CONFIG_MTD_XILINX_EMC"
	enable
}

enable_input() {
	CONFIG_PARAMETER="CONFIG_INPUT"
	enable	
}

enable_keyboard() {
	CONFIG_PARAMETER="CONFIG_INPUT_KEYBOARD"
	enable	
}

enable_fsl_ps2_kbd() {
	CONFIG_PARAMETER="CONFIG_KEYBOARD_XILINX_FSL_PS2_AT"
	enable
}

disable_fsl_ps2_kbd() {
	CONFIG_PARAMETER="CONFIG_KEYBOARD_XILINX_FSL_PS2_AT"
	disable
}

enable_xil_text_vga() {
	CONFIG_PARAMETER="CONFIG_XILINX_CONSOLE"
	enable
}

disable_xil_text_vga() {
	CONFIG_PARAMETER="CONFIG_XILINX_CONSOLE"
	disable
}

enable_vt_console() {
	CONFIG_PARAMETER="CONFIG_VT"
	enable	
	CONFIG_PARAMETER="CONFIG_VT_CONSOLE"
	enable	
	CONFIG_PARAMETER="CONFIG_HW_CONSOLE"
	enable	
}

enable_mmu() {
	CONFIG_PARAMETER="CONFIG_MMU"
	enable
	CONFIG_PARAMETER="CONFIG_SYSVIPC"
	check
	CONFIG_PARAMETER="CONFIG_SHMEM"
	check
	CONFIG_PARAMETER="CONFIG_BINFMT_ELF"
	enable
	CONFIG_PARAMETER="CONFIG_PROC_KCORE"
	check
}

disable_mmu() {
	CONFIG_PARAMETER="CONFIG_MMU"
	disable
	CONFIG_PARAMETER="CONFIG_BINFMT_FLAT"
	enable
	CONFIG_PARAMETER="CONFIG_BINFMT_ZFLAT"
	disable
	CONFIG_PARAMETER="CONFIG_BINFMT_SHARED_FLAT"
	disable	
}

enable_fsl_fifo() {
	CONFIG_PARAMETER="CONFIG_XILINX_FSLFIFO"
	enable
}

disable_fsl_fifo() {
	CONFIG_PARAMETER="CONFIG_XILINX_FSLFIFO"
	disable
}

#disabling all xilinx phys features
disable_lltemac
disable_emaclite
disable_emac
disable_temac
disable_sysace
disable_spi
disable_xilinx_iic
disable_gpio
disable_uartlite
disable_16550
disable_mtd
disable_fsl_ps2_kbd
disable_xil_text_vga
disable_mmu
disable_fsl_fifo

# enabling specific phys features and their higher level dependencies
for driver in `cat /tmp/Kconfig.auto`
do echo processing: $driver
if [ $driver = "HAVE_XILINX_TEMAC" ] ; then
	enable_temac
fi
if [ $driver = "HAVE_XILINX_EMAC" ] ; then
	enable_emac
fi
if [ $driver = "HAVE_XILINX_ETHERNETLITE" ] ; then
	enable_emaclite
fi
if [ $driver = "HAVE_XILINX_LL_TEMAC" ] ; then
	enable_lltemac
fi
if [ $driver = "HAVE_XILINX_SYSACE" ] ; then
	enable_sysace
fi
if [ $driver = "HAVE_XILINX_SPI" ] ; then
	enable_spi
fi
if [ $driver = "HAVE_XILINX_IIC" ] ; then
	enable_iic
	enable_xilinx_iic
fi
if [ $driver = "HAVE_XILINX_GPIO" ] ; then
	enable_gpio
fi
if [ $driver = "HAVE_XILINX_UART16550" ] ; then
	enable_16550
	enable_16550_console
fi
if [ $driver = "HAVE_XILINX_UARTLITE" ] ; then
	enable_uartlite
	enable_uartlite_console
fi
if [ $driver = "HAVE_XILINX_OPB_FLASH" ] ; then
	enable_mtd
	enable_opb_flash
fi
if [ $driver = "HAVE_XILINX_EMC_FLASH" ] ; then
	enable_mtd
	enable_emc_flash
fi
if [ $driver = "HAVE_XILINX_ML403_FLASH" ] ; then
	enable_mtd
	enable_ml403_flash
fi
if [ $driver = "HAVE_XILINX_FSL_PS2" ] ; then
	enable_input
	enable_keyboard
	enable_fsl_ps2_kbd
fi
if [ $driver = "HAVE_XILINX_COLOR_VIDEO_CTRL" ] ; then
	enable_vt_console
	enable_xil_text_vga
fi
if [ $driver = "MICROBLAZE_USE_MMU" ] ; then
	enable_mmu
fi
if [ $driver = "HAVE_XILINX_FSL_LINKS" ] ; then
	enable_fsl_fifo
fi
done
