-- ****************************************
-- DO NOT EDIT
-- This file was automatically generated by the Impulse C Compiler.
-- 
-- Impulse C is Copyright 2002-2005, Impulse Accelerated Technologies, Inc.
-- 
-- Stage Master is Copyright 2002-2005, Green Mountain Computing Systems, Inc.
-- 
-- All rights reserved.
-- 
-- ****************************************


-- TARGET: VHDL
  
library ieee;
use ieee.std_logic_1164.all;

package external_components is
end package;
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity complex_fir_coef_mem_RAM is
  port (
    rst,clk : in std_ulogic;
    we : in std_ulogic;
    addr : in std_ulogic_vector(8 downto 0);
    din : in std_ulogic_vector(31 downto 0);
    dout : out std_ulogic_vector(31 downto 0)
  );
end complex_fir_coef_mem_RAM;

architecture async of complex_fir_coef_mem_RAM is
  type memtype is array (0 to 431) of
    std_ulogic_vector(31 downto 0);
  signal mem : memtype;
begin
  writemem: process (clk)
  begin
    if (clk'event and clk='1') then
      if (we = '1') then
        mem(conv_integer(unsigned(addr))) <= din;
      end if;
    end if;
  end process;

  dout <= mem(conv_integer(unsigned(addr)));
end async;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity complex_fir_filt_hist_RAM is
  port (
    rst,clk : in std_ulogic;
    we : in std_ulogic;
    addr : in std_ulogic_vector(8 downto 0);
    din : in std_ulogic_vector(31 downto 0);
    dout : out std_ulogic_vector(31 downto 0)
  );
end complex_fir_filt_hist_RAM;

architecture async of complex_fir_filt_hist_RAM is
  type memtype is array (0 to 431) of
    std_ulogic_vector(31 downto 0);
  signal mem : memtype;
begin
  writemem: process (clk)
  begin
    if (clk'event and clk='1') then
      if (we = '1') then
        mem(conv_integer(unsigned(addr))) <= din;
      end if;
    end if;
  end process;

  dout <= mem(conv_integer(unsigned(addr)));
end async;

library ieee;
use ieee.std_logic_1164.all;

library impulse;
use impulse.components.all;
  
entity complex_fir is
  port (signal reset : in std_ulogic;
    signal sclk : in std_ulogic;
    signal clk : in std_ulogic;
    signal p_filter_in_rdy : in std_ulogic;
    signal p_filter_in_en : inout std_ulogic;
    signal p_filter_in_eos : in std_ulogic;
    signal p_filter_in_data : in std_ulogic_vector (31 downto 0);
    signal p_filter_out_rdy : in std_ulogic;
    signal p_filter_out_en : inout std_ulogic;
    signal p_filter_out_eos : out std_ulogic;
    signal p_filter_out_data : out std_ulogic_vector (31 downto 0));
end complex_fir;

use work.external_components.all;
architecture rtl of complex_fir is
  function mkvec(b : in std_ulogic) return std_ulogic_vector is
    variable res : std_ulogic_vector(0 downto 0);
  begin
    res(0):=b;
    return(res);
  end;

  component complex_fir_coef_mem_RAM is
    port (signal rst : in std_ulogic;
      signal clk : in std_ulogic;
      signal we : in std_ulogic;
      signal addr : in std_ulogic_vector (8 downto 0);
      signal din : in std_ulogic_vector (31 downto 0);
      signal dout : out std_ulogic_vector (31 downto 0));
  end component;

  component complex_fir_filt_hist_RAM is
    port (signal rst : in std_ulogic;
      signal clk : in std_ulogic;
      signal we : in std_ulogic;
      signal addr : in std_ulogic_vector (8 downto 0);
      signal din : in std_ulogic_vector (31 downto 0);
      signal dout : out std_ulogic_vector (31 downto 0));
  end component;

  type stateType is (init, b0s0, b1s0, b2s0, b2s1, b3s0, b4s0, b5s0, b6s0, b7s0, b8s0, b9s0, b10s0, b11s0, finished);
  type pipeStateType is (idle, init, run, flush);
  type t_b1_0 is record
     f_suif_tmp00 : std_ulogic_vector (31 downto 0);
  end record;
  type t_b8_0 is record
     predicates : std_ulogic_vector (1 downto 0);
     f_i0 : std_ulogic_vector (31 downto 0);
  end record;
  type t_b8_1 is record
     predicates : std_ulogic_vector (1 downto 0);
     f_suif_tmp_1 : std_ulogic_vector (31 downto 0);
     f_t_read_idx : std_ulogic_vector (31 downto 0);
  end record;
  type t_b8_2 is record
     predicates : std_ulogic_vector (1 downto 0);
     f_coef_real : std_ulogic_vector (15 downto 0);
     f_coef_imag : std_ulogic_vector (15 downto 0);
  end record;
  type t_b8_3 is record
     predicates : std_ulogic_vector (1 downto 0);
     f_coef_real : std_ulogic_vector (15 downto 0);
     f_coef_imag : std_ulogic_vector (15 downto 0);
     f_hist_real : std_ulogic_vector (15 downto 0);
     f_hist_imag : std_ulogic_vector (15 downto 0);
  end record;
  type t_b8_4 is record
     predicates : std_ulogic_vector (1 downto 0);
     f_p1_real : std_ulogic_vector (31 downto 0);
     f_p1_imag : std_ulogic_vector (31 downto 0);
     f_p2_real : std_ulogic_vector (31 downto 0);
     f_p2_imag : std_ulogic_vector (31 downto 0);
  end record;
  type t_b8_5 is record
     predicates : std_ulogic_vector (1 downto 0);
     f_res_real : std_ulogic_vector (31 downto 0);
     f_res_imag : std_ulogic_vector (31 downto 0);
  end record;
  type t_b8_6 is record
     predicates : std_ulogic_vector (1 downto 0);
     f_accum_real : std_ulogic_vector (31 downto 0);
     f_accum_imag : std_ulogic_vector (31 downto 0);
  end record;
  signal thisState : stateType;
  signal nextState : stateType;
  signal stateEn : std_ulogic;
  signal newState : std_ulogic;
  signal r_filter_in : std_ulogic_vector (31 downto 0);
  signal r_i0 : std_ulogic_vector (31 downto 0);
  signal ni348_i0 : std_ulogic_vector (31 downto 0);
  signal r_coef_mem : std_ulogic_vector (31 downto 0);
  signal ni69_coef_mem : std_ulogic_vector (31 downto 0);
  signal p_coef_mem_we : std_ulogic;
  signal p_coef_mem_din : std_ulogic_vector (31 downto 0);
  signal p_coef_mem_dout : std_ulogic_vector (31 downto 0);
  signal p_coef_mem_addr : std_ulogic_vector (8 downto 0);
  signal p_coef_mem_re : std_ulogic;
  signal r_filt_hist : std_ulogic_vector (31 downto 0);
  signal ni77_filt_hist : std_ulogic_vector (31 downto 0);
  signal ni103_filt_hist : std_ulogic_vector (31 downto 0);
  signal p_filt_hist_we : std_ulogic;
  signal p_filt_hist_din : std_ulogic_vector (31 downto 0);
  signal p_filt_hist_dout : std_ulogic_vector (31 downto 0);
  signal p_filt_hist_addr : std_ulogic_vector (8 downto 0);
  signal p_filt_hist_re : std_ulogic;
  signal r_inSample : std_ulogic_vector (31 downto 0);
  signal ni306_inSample : std_ulogic_vector (31 downto 0);
  signal ni311_inSample : std_ulogic_vector (31 downto 0);
  signal r_outFilter : std_ulogic_vector (31 downto 0);
  signal ni347_outFilter : std_ulogic_vector (31 downto 0);
  signal r_i : std_ulogic_vector (31 downto 0);
  signal ni305_i : std_ulogic_vector (31 downto 0);
  signal ni308_i : std_ulogic_vector (31 downto 0);
  signal ni322_i : std_ulogic_vector (31 downto 0);
  signal ni344_i : std_ulogic_vector (31 downto 0);
  signal r_write_idx : std_ulogic_vector (31 downto 0);
  signal ni303_write_idx : std_ulogic_vector (31 downto 0);
  signal ni313_write_idx : std_ulogic_vector (31 downto 0);
  signal ni314_write_idx : std_ulogic_vector (31 downto 0);
  signal r_read_idx : std_ulogic_vector (31 downto 0);
  signal ni304_read_idx : std_ulogic_vector (31 downto 0);
  signal ni316_read_idx : std_ulogic_vector (31 downto 0);
  signal ni319_read_idx : std_ulogic_vector (31 downto 0);
  signal r_t_read_idx : std_ulogic_vector (31 downto 0);
  signal ni317_t_read_idx : std_ulogic_vector (31 downto 0);
  signal ni326_t_read_idx : std_ulogic_vector (31 downto 0);
  signal ni329_t_read_idx : std_ulogic_vector (31 downto 0);
  signal r_t_coef : std_ulogic_vector (31 downto 0);
  signal ni324_t_coef : std_ulogic_vector (31 downto 0);
  signal r_t_hist : std_ulogic_vector (31 downto 0);
  signal ni327_t_hist : std_ulogic_vector (31 downto 0);
  signal r_coef_real : std_ulogic_vector (15 downto 0);
  signal ni330_coef_real : std_ulogic_vector (15 downto 0);
  signal r_coef_imag : std_ulogic_vector (15 downto 0);
  signal ni331_coef_imag : std_ulogic_vector (15 downto 0);
  signal r_hist_real : std_ulogic_vector (15 downto 0);
  signal ni332_hist_real : std_ulogic_vector (15 downto 0);
  signal r_hist_imag : std_ulogic_vector (15 downto 0);
  signal ni333_hist_imag : std_ulogic_vector (15 downto 0);
  signal r_p1_real : std_ulogic_vector (31 downto 0);
  signal ni334_p1_real : std_ulogic_vector (31 downto 0);
  signal r_p2_real : std_ulogic_vector (31 downto 0);
  signal ni336_p2_real : std_ulogic_vector (31 downto 0);
  signal r_p1_imag : std_ulogic_vector (31 downto 0);
  signal ni335_p1_imag : std_ulogic_vector (31 downto 0);
  signal r_p2_imag : std_ulogic_vector (31 downto 0);
  signal ni337_p2_imag : std_ulogic_vector (31 downto 0);
  signal r_res_real : std_ulogic_vector (31 downto 0);
  signal ni338_res_real : std_ulogic_vector (31 downto 0);
  signal ni340_res_real : std_ulogic_vector (31 downto 0);
  signal r_res_imag : std_ulogic_vector (31 downto 0);
  signal ni339_res_imag : std_ulogic_vector (31 downto 0);
  signal ni341_res_imag : std_ulogic_vector (31 downto 0);
  signal r_accum_real : std_ulogic_vector (31 downto 0);
  signal ni320_accum_real : std_ulogic_vector (31 downto 0);
  signal ni342_accum_real : std_ulogic_vector (31 downto 0);
  signal ni345_accum_real : std_ulogic_vector (31 downto 0);
  signal r_accum_imag : std_ulogic_vector (31 downto 0);
  signal ni321_accum_imag : std_ulogic_vector (31 downto 0);
  signal ni343_accum_imag : std_ulogic_vector (31 downto 0);
  signal ni346_accum_imag : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp : std_ulogic_vector (31 downto 0);
  signal ni309_suif_tmp : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp0 : std_ulogic_vector (31 downto 0);
  signal ni310_suif_tmp0 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp1 : std_ulogic_vector (31 downto 0);
  signal ni312_suif_tmp1 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp2 : std_ulogic_vector (31 downto 0);
  signal ni318_suif_tmp2 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp3 : std_ulogic_vector (31 downto 0);
  signal ni323_suif_tmp3 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp4 : std_ulogic_vector (31 downto 0);
  signal ni328_suif_tmp4 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp00 : std_ulogic_vector (31 downto 0);
  signal ni307_suif_tmp00 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp_0 : std_ulogic_vector (31 downto 0);
  signal ni315_suif_tmp_0 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp_1 : std_ulogic_vector (31 downto 0);
  signal ni325_suif_tmp_1 : std_ulogic_vector (31 downto 0);
  signal t_3 : std_ulogic_vector (31 downto 0);
  signal ti152_filt_hist : std_ulogic_vector (8 downto 0);
  signal ti144_coef_mem : std_ulogic_vector (8 downto 0);
  signal t_2 : std_ulogic_vector (8 downto 0);
  signal t_1 : std_ulogic_vector (8 downto 0);
  signal t_0 : std_ulogic_vector (8 downto 0);
  signal s_b1_state : pipeStateType;
  signal s_b1_0 : t_b1_0;
  signal s_b1_stall : std_ulogic;
  signal s_b1_break : std_ulogic;
  signal s_b1_final : std_ulogic;
  signal s_b1_flushing : std_ulogic;
  signal s_b1_flushed : std_ulogic;
  signal s_b1_done : std_ulogic;
  signal s_b1_vstall : std_ulogic_vector (1 downto 0);
  signal s_b1_vbreak : std_ulogic_vector (1 downto 0);
  signal s_b1_stage : std_ulogic_vector (1 downto 0);
  signal s_b1_vwrite : std_ulogic_vector (1 downto 0);
  signal s_b1_vcont : std_ulogic_vector (1 downto 0);
  signal s_b1_delay : std_ulogic_vector (1 downto 0);
  signal s_b8_state : pipeStateType;
  signal s_b8_0 : t_b8_0;
  signal s_b8_1 : t_b8_1;
  signal s_b8_2 : t_b8_2;
  signal s_b8_3 : t_b8_3;
  signal s_b8_4 : t_b8_4;
  signal s_b8_5 : t_b8_5;
  signal s_b8_6 : t_b8_6;
  signal s_b8_stall : std_ulogic;
  signal s_b8_break : std_ulogic;
  signal s_b8_final : std_ulogic;
  signal s_b8_flushing : std_ulogic;
  signal s_b8_flushed : std_ulogic;
  signal s_b8_done : std_ulogic;
  signal s_b8_vstall : std_ulogic_vector (6 downto 0);
  signal s_b8_vbreak : std_ulogic_vector (6 downto 0);
  signal s_b8_stage : std_ulogic_vector (6 downto 0);
  signal s_b8_vwrite : std_ulogic_vector (6 downto 0);
  signal s_b8_vcont : std_ulogic_vector (6 downto 0);
  signal s_b8_delay : std_ulogic_vector (1 downto 0);
  signal s_b8_predicates : std_ulogic_vector (1 downto 0);
begin
  process (clk,reset)
  begin
    if (reset='1') then
     thisState <= init;
    elsif (clk'event and clk='1') then
      if (stateEn = '1') then
        thisState <= nextState;
      end if;
    end if;
  end process;

  stateEn <= 
    '0' when thisState = b1s0 and s_b1_done = '0' else
    '0' when thisState = b2s0 and p_filter_in_rdy = '0' else
    '0' when thisState = b8s0 and s_b8_done = '0' else
    '0' when thisState = b9s0 and p_filter_out_rdy = '0' else
    '0' when thisState = b10s0 and (p_filter_in_eos and p_filter_out_rdy) = '0' else
    '1';

  process (ni318_suif_tmp2,ni312_suif_tmp1,ni310_suif_tmp0,thisState)
  begin
    case thisState is
    when init =>
      nextState <= b0s0;
    when b0s0 =>
      nextState <= b1s0;
    when b1s0 =>
      nextState <= b2s0;
    when b2s0 =>
      if ((not ni310_suif_tmp0(0)) = '1') then
        nextState <= b10s0;
      else
        nextState <= b2s1;
      end if;
    when b2s1 =>
      if (ni312_suif_tmp1(0) = '1') then
        nextState <= b3s0;
      elsif ((not ni312_suif_tmp1(0)) = '1') then
        nextState <= b4s0;
      else
        nextState <= b2s1;
      end if;
    when b3s0 =>
      nextState <= b5s0;
    when b4s0 =>
      nextState <= b5s0;
    when b5s0 =>
      if (ni318_suif_tmp2(0) = '1') then
        nextState <= b6s0;
      elsif ((not ni318_suif_tmp2(0)) = '1') then
        nextState <= b7s0;
      else
        nextState <= b5s0;
      end if;
    when b6s0 =>
      nextState <= b7s0;
    when b7s0 =>
      nextState <= b8s0;
    when b8s0 =>
      nextState <= b9s0;
    when b9s0 =>
      nextState <= b2s0;
    when b10s0 =>
      nextState <= b0s0;
    when b11s0 =>
      nextState <= finished;
    when finished =>
      nextState <= finished;
    when others =>
      nextState <= init;
    end case;
  end process;

  process (clk,reset)
  begin
    if (reset='1') then
     newState <= '1';
    elsif (clk'event and clk='1') then
      case thisState is
      when b1s0 =>
       newState <= not s_b1_stall;
      when b8s0 =>
       newState <= not s_b8_stall;
      when  others =>
       newState <= stateEn;
      end case;
    end if;
  end process;

-- b0s0
  ni303_write_idx <= X"000001af";
  ni304_read_idx <= X"00000000";
  ni305_i <= X"00000000";

  process (clk,reset)
  begin
    if (reset='1') then
     s_b1_state <= idle;
    elsif (clk'event and clk='1') then
      case s_b1_state is
      when idle =>
        if (stateEn = '1' and nextState = b1s0) then
          s_b1_state <= init;
        else
          s_b1_state <= idle;
        end if;
      when init =>
        s_b1_state <= run;
      when run =>
        if (s_b1_final = '1' and s_b1_stall = '0') then
          s_b1_state <= flush;
        elsif (s_b1_break = '1') then
          s_b1_state <= flush;
        else
          s_b1_state <= run;
        end if;
      when flush =>
        if (s_b1_flushed = '1') then
          s_b1_state <= idle;
        else
          s_b1_state <= flush;
        end if;
      when others => null;
      end case;
    end if;
  end process;

-- b1 stage 0
  s_b1_vstall(0) <= 
    '0' when p_filter_in_rdy = '1' or s_b1_final = '1' else
    '1';
  ni307_suif_tmp00 <= r_i;
  s_b1_vbreak(0) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b1_vwrite(0) = '1') then
        s_b1_0.f_suif_tmp00 <= ni307_suif_tmp00;
      end if;
    end if;
  end process;

-- b1 stage 1
  s_b1_vstall(1) <= '0';
  ni306_inSample <= r_filter_in;
  ni69_coef_mem <= ni306_inSample;
  t_0 <= r_i(8 downto 0);
  ni308_i <= add(s_b1_0.f_suif_tmp00, X"00000001");
  ni77_filt_hist <= X"00000000";
  t_1 <= s_b1_0.f_suif_tmp00(8 downto 0);
  ni309_suif_tmp <= "0000000000000000000000000000000" & cmp_less_s(ni308_i, X"000001b0");
  s_b1_vbreak(1) <= '0';
  with s_b1_state select
    s_b1_break <= 
      '1' when flush,
      '0' when others;
  process (clk,reset)
  begin
    if (reset='1') then
     s_b1_delay <= "01";
    elsif (clk'event and clk='1') then
      if (s_b1_state = idle) then
       s_b1_delay <= "01";
      elsif (thisState = b1s0 and s_b1_stall = '0' and s_b1_done = '0') then
       s_b1_delay <= s_b1_delay(0) & s_b1_delay(1 downto 1);
      end if;    end if;
  end process;

  process (clk,reset)
  begin
    if (reset='1') then
     s_b1_stage <= "00";
    elsif (clk'event and clk='1') then
      if (s_b1_state = idle) then
       s_b1_stage <= "00";
      elsif (thisState = b1s0 and s_b1_stall = '0') then
       s_b1_stage <= s_b1_vcont(0 downto 0) & ((not s_b1_break) and (not s_b1_flushing) and s_b1_delay(0));
      end if;    end if;
  end process;

  s_b1_stall <= 
    '0' when (s_b1_vstall and s_b1_stage) = "00" else
    '1';
  s_b1_vwrite(0) <= 
    s_b1_stage(0) when s_b1_stall = '0' and s_b1_final = '0' else
    '0';
  s_b1_vwrite(1) <= 
    s_b1_stage(1) when s_b1_stall = '0' else
    '0';
  s_b1_vcont(0) <= s_b1_stage(0) and (not s_b1_final);
  s_b1_vcont(1) <= '0';
  s_b1_final <= 
    '1' when (s_b1_stage(1) and (not ni309_suif_tmp(0))) = '1' else
    '0';
  s_b1_flushing <= 
    '1' when s_b1_state = flush else
    s_b1_final;
  s_b1_flushed <= 
    '1' when s_b1_stall = '0' and s_b1_vcont = "00" else
    '0';
  with s_b1_state select
    s_b1_done <= 
      '0' when init,
      '0' when run,
      s_b1_flushed when flush,
      '0' when others;
-- b2s0
  ni310_suif_tmp0 <= "0000000000000000000000000000000" & eq("0" & mkvec(p_filter_in_eos), "00");

-- b2s1
  ni311_inSample <= r_filter_in;
  ni103_filt_hist <= ni311_inSample;
  t_2 <= r_write_idx(8 downto 0);
  ni312_suif_tmp1 <= "0000000000000000000000000000000" & eq(r_write_idx, X"000001af");

-- b3s0
  ni313_write_idx <= X"00000000";

-- b4s0
  ni314_write_idx <= add(r_write_idx, X"00000001");

-- b5s0
  ni315_suif_tmp_0 <= r_read_idx;
  ni316_read_idx <= add(ni315_suif_tmp_0, X"00000001");
  ni317_t_read_idx <= ni315_suif_tmp_0;
  ni318_suif_tmp2 <= "0000000000000000000000000000000" & cmp_less_equal_s(X"000001b0", ni316_read_idx);

-- b6s0
  ni319_read_idx <= X"00000000";

-- b7s0
  ni320_accum_real <= X"00000000";
  ni321_accum_imag <= X"00000000";
  ni322_i <= X"00000000";

  process (clk,reset)
  begin
    if (reset='1') then
     s_b8_state <= idle;
    elsif (clk'event and clk='1') then
      case s_b8_state is
      when idle =>
        if (stateEn = '1' and nextState = b8s0) then
          s_b8_state <= init;
        else
          s_b8_state <= idle;
        end if;
      when init =>
        s_b8_state <= run;
      when run =>
        if (s_b8_break = '1') then
          s_b8_state <= flush;
        else
          s_b8_state <= run;
        end if;
      when flush =>
        if (s_b8_flushed = '1') then
          s_b8_state <= idle;
        else
          s_b8_state <= flush;
        end if;
      when others => null;
      end case;
    end if;
  end process;

-- b8 stage 0
  s_b8_vstall(0) <= '0';
  ni348_i0 <= r_i;
  ni344_i <= add(r_i, X"00000001");
  ni323_suif_tmp3 <= "0000000000000000000000000000000" & cmp_less_s(ni348_i0, X"000001b0");
  s_b8_vbreak(0) <= 
    '1' when (not ni323_suif_tmp3(0)) = '1' else
    '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b8_vwrite(0) = '1') then
        s_b8_0.f_i0 <= ni348_i0;
        s_b8_0.predicates(0) <= '0';
        s_b8_0.predicates(1) <= '0';
      end if;
    end if;
  end process;

-- b8 stage 1
  s_b8_vstall(1) <= '0';
  ti144_coef_mem <= s_b8_0.f_i0(8 downto 0);
  ni325_suif_tmp_1 <= r_t_read_idx;
  ni326_t_read_idx <= add(ni325_suif_tmp_1, X"00000001");
  s_b8_vbreak(1) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b8_vwrite(1) = '1') then
        s_b8_1.f_t_read_idx <= ni326_t_read_idx;
        s_b8_1.f_suif_tmp_1 <= ni325_suif_tmp_1;
        s_b8_1.predicates(0) <= s_b8_0.predicates(0);
        s_b8_1.predicates(1) <= s_b8_0.predicates(1);
      end if;
    end if;
  end process;

-- b8 stage 2
  s_b8_vstall(2) <= '0';
  ni324_t_coef <= r_coef_mem;
  ti152_filt_hist <= s_b8_1.f_suif_tmp_1(8 downto 0);
  ni328_suif_tmp4 <= "0000000000000000000000000000000" & cmp_less_equal_s(X"000001b0", s_b8_1.f_t_read_idx);
  ni329_t_read_idx <= X"00000000";
  s_b8_predicates(0) <= 
    '1' when ni328_suif_tmp4(0) = '1' else
    '0';
  s_b8_predicates(1) <= 
    '1' when (not ni328_suif_tmp4(0)) = '1' else
    '0';
  ni330_coef_real <= lshr(ni324_t_coef, 16)(15 downto 0) and X"ffff";
  ni331_coef_imag <= ni324_t_coef(15 downto 0) and X"ffff";
  t_3 <= 
    ni329_t_read_idx when s_b8_predicates(0) = '1' else
    s_b8_1.f_t_read_idx;
  s_b8_vbreak(2) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b8_vwrite(2) = '1') then
        s_b8_2.f_coef_imag <= ni331_coef_imag;
        s_b8_2.f_coef_real <= ni330_coef_real;
        s_b8_2.predicates(0) <= s_b8_predicates(0);
        s_b8_2.predicates(1) <= s_b8_predicates(1);
      end if;
    end if;
  end process;

-- b8 stage 3
  s_b8_vstall(3) <= '0';
  ni327_t_hist <= r_filt_hist;
  ni332_hist_real <= lshr(ni327_t_hist, 16)(15 downto 0) and X"ffff";
  ni333_hist_imag <= ni327_t_hist(15 downto 0) and X"ffff";
  s_b8_vbreak(3) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b8_vwrite(3) = '1') then
        s_b8_3.f_hist_imag <= ni333_hist_imag;
        s_b8_3.f_hist_real <= ni332_hist_real;
        s_b8_3.f_coef_imag <= s_b8_2.f_coef_imag;
        s_b8_3.f_coef_real <= s_b8_2.f_coef_real;
        s_b8_3.predicates(0) <= s_b8_2.predicates(0);
        s_b8_3.predicates(1) <= s_b8_2.predicates(1);
      end if;
    end if;
  end process;

-- b8 stage 4
  s_b8_vstall(4) <= '0';
  ni334_p1_real <= mul2_s(s_b8_3.f_coef_real, s_b8_3.f_hist_real);
  ni335_p1_imag <= mul2_s(s_b8_3.f_coef_real, s_b8_3.f_hist_imag);
  ni336_p2_real <= mul2_s(s_b8_3.f_coef_imag, s_b8_3.f_hist_imag);
  ni337_p2_imag <= mul2_s(s_b8_3.f_coef_imag, s_b8_3.f_hist_real);
  s_b8_vbreak(4) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b8_vwrite(4) = '1') then
        s_b8_4.f_p2_imag <= ni337_p2_imag;
        s_b8_4.f_p2_real <= ni336_p2_real;
        s_b8_4.f_p1_imag <= ni335_p1_imag;
        s_b8_4.f_p1_real <= ni334_p1_real;
        s_b8_4.predicates(0) <= s_b8_3.predicates(0);
        s_b8_4.predicates(1) <= s_b8_3.predicates(1);
      end if;
    end if;
  end process;

-- b8 stage 5
  s_b8_vstall(5) <= '0';
  ni338_res_real <= sub(s_b8_4.f_p1_real, s_b8_4.f_p2_real);
  ni339_res_imag <= add(s_b8_4.f_p1_imag, s_b8_4.f_p2_imag);
  ni340_res_real <= ashr(ni338_res_real, 12);
  ni341_res_imag <= ashr(ni339_res_imag, 12);
  s_b8_vbreak(5) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b8_vwrite(5) = '1') then
        s_b8_5.f_res_imag <= ni341_res_imag;
        s_b8_5.f_res_real <= ni340_res_real;
        s_b8_5.predicates(0) <= s_b8_4.predicates(0);
        s_b8_5.predicates(1) <= s_b8_4.predicates(1);
      end if;
    end if;
  end process;

-- b8 stage 6
  s_b8_vstall(6) <= '0';
  ni342_accum_real <= add(s_b8_6.f_accum_real, s_b8_5.f_res_real);
  ni343_accum_imag <= add(s_b8_6.f_accum_imag, s_b8_5.f_res_imag);
  s_b8_vbreak(6) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b8_state = init) then
        s_b8_6.f_accum_imag <= r_accum_imag;
        s_b8_6.f_accum_real <= r_accum_real;
      elsif (s_b8_vwrite(6) = '1') then
        s_b8_6.f_accum_imag <= ni343_accum_imag;
        s_b8_6.f_accum_real <= ni342_accum_real;
        s_b8_6.predicates(0) <= s_b8_5.predicates(0);
        s_b8_6.predicates(1) <= s_b8_5.predicates(1);
      end if;
    end if;
  end process;

  with s_b8_state select
    s_b8_break <= 
      s_b8_vbreak(0) and s_b8_stage(0) when run,
      '1' when flush,
      '0' when others;
  process (clk,reset)
  begin
    if (reset='1') then
     s_b8_delay <= "01";
    elsif (clk'event and clk='1') then
      if (s_b8_state = idle) then
       s_b8_delay <= "01";
      elsif (thisState = b8s0 and s_b8_stall = '0' and s_b8_done = '0') then
       s_b8_delay <= s_b8_delay(0) & s_b8_delay(1 downto 1);
      end if;    end if;
  end process;

  process (clk,reset)
  begin
    if (reset='1') then
     s_b8_stage <= "0000000";
    elsif (clk'event and clk='1') then
      if (s_b8_state = idle) then
       s_b8_stage <= "0000000";
      elsif (thisState = b8s0 and s_b8_stall = '0') then
       s_b8_stage <= s_b8_vcont(5 downto 0) & ((not s_b8_break) and (not s_b8_flushing) and s_b8_delay(0));
      end if;    end if;
  end process;

  s_b8_stall <= 
    '0' when (s_b8_vstall and s_b8_stage) = "0000000" else
    '1';
  s_b8_vwrite(0) <= 
    s_b8_stage(0) when s_b8_stall = '0' and s_b8_final = '0' else
    '0';
  s_b8_vwrite(1) <= 
    s_b8_stage(1) when s_b8_stall = '0' and s_b8_final = '0' else
    '0';
  s_b8_vwrite(2) <= 
    s_b8_stage(2) when s_b8_stall = '0' and s_b8_final = '0' else
    '0';
  s_b8_vwrite(3) <= 
    s_b8_stage(3) when s_b8_stall = '0' and s_b8_final = '0' else
    '0';
  s_b8_vwrite(4) <= 
    s_b8_stage(4) when s_b8_stall = '0' and s_b8_final = '0' else
    '0';
  s_b8_vwrite(5) <= 
    s_b8_stage(5) when s_b8_stall = '0' and s_b8_final = '0' else
    '0';
  s_b8_vwrite(6) <= 
    s_b8_stage(6) when s_b8_stall = '0' else
    '0';
  s_b8_vcont(0) <= s_b8_stage(0) and (not s_b8_vbreak(0)) and (not s_b8_final);
  s_b8_vcont(1) <= s_b8_stage(1) and (not s_b8_final);
  s_b8_vcont(2) <= s_b8_stage(2) and (not s_b8_final);
  s_b8_vcont(3) <= s_b8_stage(3) and (not s_b8_final);
  s_b8_vcont(4) <= s_b8_stage(4) and (not s_b8_final);
  s_b8_vcont(5) <= s_b8_stage(5) and (not s_b8_final);
  s_b8_vcont(6) <= '0';
  s_b8_final <= '0';
  s_b8_flushing <= 
    '1' when s_b8_state = flush else
    s_b8_final;
  s_b8_flushed <= 
    '1' when s_b8_stall = '0' and s_b8_vcont = "0000000" else
    '0';
  with s_b8_state select
    s_b8_done <= 
      '0' when init,
      '0' when run,
      s_b8_flushed when flush,
      '0' when others;
-- b9s0
  ni345_accum_real <= ashr(r_accum_real, 13);
  ni346_accum_imag <= ashr(r_accum_imag, 13);
  ni347_outFilter <= add(shl(ni345_accum_real and X"0000ffff", 16), ni346_accum_imag and X"0000ffff");

-- b10s0

-- b11s0

-- 


  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b0s0 =>
        if (stateEn = '1') then
          r_write_idx <= ni303_write_idx;
        end if;
      when b3s0 =>
        if (stateEn = '1') then
          r_write_idx <= ni313_write_idx;
        end if;
      when b4s0 =>
        if (stateEn = '1') then
          r_write_idx <= ni314_write_idx;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b0s0 =>
        if (stateEn = '1') then
          r_read_idx <= ni304_read_idx;
        end if;
      when b5s0 =>
        if (stateEn = '1') then
          r_read_idx <= ni316_read_idx;
        end if;
      when b6s0 =>
        if (stateEn = '1') then
          r_read_idx <= ni319_read_idx;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b0s0 =>
        if (stateEn = '1') then
          r_i <= ni305_i;
        end if;
      when b1s0 =>
        if (s_b1_vwrite(1) = '1') then
          r_i <= ni308_i;
        end if;
      when b7s0 =>
        if (stateEn = '1') then
          r_i <= ni322_i;
        end if;
      when b8s0 =>
        if (s_b8_vwrite(0) = '1') then
          r_i <= ni344_i;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b2s0 =>
        if (stateEn = '1') then
          r_suif_tmp0 <= ni310_suif_tmp0;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b2s1 =>
        if (stateEn = '1') then
          r_inSample <= ni311_inSample;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b2s1 =>
        if (stateEn = '1') then
          r_suif_tmp1 <= ni312_suif_tmp1;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b5s0 =>
        if (stateEn = '1') then
          r_suif_tmp_0 <= ni315_suif_tmp_0;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b5s0 =>
        if (stateEn = '1') then
          r_t_read_idx <= ni317_t_read_idx;
        end if;
      when b8s0 =>
        if (s_b8_vwrite(1) = '1') then
          r_t_read_idx <= ni326_t_read_idx;
        end if;
        if (s_b8_vwrite(2) = '1') then
          r_t_read_idx <= t_3;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b5s0 =>
        if (stateEn = '1') then
          r_suif_tmp2 <= ni318_suif_tmp2;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b7s0 =>
        if (stateEn = '1') then
          r_accum_real <= ni320_accum_real;
        end if;
      when b8s0 =>
        if (s_b8_vbreak(0) = '1') then
          r_accum_real <= s_b8_6.f_accum_real;
        end if;
        if (s_b8_vwrite(6) = '1') then
          r_accum_real <= ni342_accum_real;
        end if;
      when b9s0 =>
        if (stateEn = '1') then
          r_accum_real <= ni345_accum_real;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b7s0 =>
        if (stateEn = '1') then
          r_accum_imag <= ni321_accum_imag;
        end if;
      when b8s0 =>
        if (s_b8_vbreak(0) = '1') then
          r_accum_imag <= s_b8_6.f_accum_imag;
        end if;
        if (s_b8_vwrite(6) = '1') then
          r_accum_imag <= ni343_accum_imag;
        end if;
      when b9s0 =>
        if (stateEn = '1') then
          r_accum_imag <= ni346_accum_imag;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b9s0 =>
        if (stateEn = '1') then
          r_outFilter <= ni347_outFilter;
        end if;
      when others => null;
      end case;
    end if;
  end process;

-- "filter_in" interface signals
  process (clk)
  begin
    if (clk'event and clk='1') then
      if ((p_filter_in_en and p_filter_in_rdy) = '1') then
        r_filter_in <= p_filter_in_data;
      end if;
    end if;
  end process;

  p_filter_in_en <= 
    '1' and (not p_filter_in_eos) when s_b1_vwrite(0) = '1' and thisState = b1s0 else
    stateEn and (not p_filter_in_eos) when thisState = b2s0 else
    stateEn when thisState = b10s0 else
    '0';

-- "filter_out" interface signals
  p_filter_out_en <= 
    stateEn when thisState = b9s0 else
    stateEn when thisState = b10s0 else
    '0';
  p_filter_out_data <= ni347_outFilter;
  p_filter_out_eos <= 
    '1' when thisState = b10s0 else
    '0';

-- "coef_mem" memory signals
  ram_0: complex_fir_coef_mem_RAM
    port map (
      rst => reset, 
      clk => clk, 
      we => p_coef_mem_we, 
      addr => p_coef_mem_addr, 
      din => p_coef_mem_din, 
      dout => p_coef_mem_dout);

  p_coef_mem_addr <= 
    r_i(8 downto 0) when thisState = b1s0 and s_b1_stage(1) = '1' else
    s_b8_0.f_i0(8 downto 0) when thisState = b8s0 and s_b8_vwrite(1) = '1' else
    (others => 'X');
  p_coef_mem_re <= 
    '1' when thisState = b8s0 and s_b8_vwrite(1) = '1' else
    '0';
  p_coef_mem_we <= 
    '1' when thisState = b1s0 and s_b1_stage(1) = '1' else
    '0';
  p_coef_mem_din <= ni306_inSample;
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (p_coef_mem_re = '1') then
        r_coef_mem <= p_coef_mem_dout;
      end if;
    end if;
  end process;

-- "filt_hist" memory signals
  ram_1: complex_fir_filt_hist_RAM
    port map (
      rst => reset, 
      clk => clk, 
      we => p_filt_hist_we, 
      addr => p_filt_hist_addr, 
      din => p_filt_hist_din, 
      dout => p_filt_hist_dout);

  p_filt_hist_addr <= 
    s_b1_0.f_suif_tmp00(8 downto 0) when thisState = b1s0 and s_b1_stage(1) = '1' else
    r_write_idx(8 downto 0) when thisState = b2s1 else
    s_b8_1.f_suif_tmp_1(8 downto 0) when thisState = b8s0 and s_b8_vwrite(2) = '1' else
    (others => 'X');
  p_filt_hist_re <= 
    '1' when thisState = b8s0 and s_b8_vwrite(2) = '1' else
    '0';
  p_filt_hist_we <= 
    '1' when thisState = b1s0 and s_b1_stage(1) = '1' else
    '1' when thisState = b2s1 else
    '0';
  p_filt_hist_din <= 
    ni77_filt_hist when thisState = b1s0 and s_b1_stage(1) = '1' else
    ni311_inSample when thisState = b2s1 else
    (others => 'X');
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (p_filt_hist_re = '1') then
        r_filt_hist <= p_filt_hist_dout;
      end if;
    end if;
  end process;

end rtl;
